module MyEcho where

import Char
import MyIO

myPutStr :: String -> MyIO ()
myPutStr =  foldr (>>) (return ()) . map myPutChar

myPutStrLn :: String -> MyIO ()
myPutStrLn s  =  myPutStr s >> myPutChar '\n'

myGetLine :: MyIO String
myGetLine =  myGetChar >>= \x ->
             if x == '\n' then
               return []
             else 
               myGetLine >>= \xs ->
               return (x:xs)

myEcho :: MyIO ()
myEcho =  myGetLine >>= \line ->
          if line == "" then
            return ()
          else
            myPutStrLn (map toUpper line) >>
            myEcho

main :: IO ()
main =  convert myEcho
